#include "stdafx.h"
#include "SQLViewApp.h"
#include "OpenDlg.h"
#include "ColumnFormatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CColumnFormatDlg, CDialog)
	//{{AFX_MSG_MAP(CColumnFormatDlg)
	ON_EN_KILLFOCUS(ID_COLUMNFORMAT_FIELDFORMAT, OnKillFocusFieldFormat)
	ON_EN_KILLFOCUS(ID_COLUMNFORMAT_WIDTH, OnKillFocusWidth)
	ON_BN_CLICKED(ID_COLUMNFORMAT_OK, OnOK)
	ON_BN_CLICKED(ID_COLUMNFORMAT_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CColumnFormatDlg::CColumnFormatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CColumnFormatDlg::IDD, pParent),
	m_pOpenDlg(static_cast<COpenDlg*>(pParent))
{
	//{{AFX_DATA_INIT(CColumnFormatDlg)
	//}}AFX_DATA_INIT
}


CColumnFormatDlg::CColumnFormatDlg(CWnd* pParent, COpenDlg::CColumnData ColumnData)
	: CDialog(CColumnFormatDlg::IDD, pParent),
	m_pOpenDlg(static_cast<COpenDlg*>(pParent)),
	m_sFieldName(ColumnData.sFieldName),
	m_sFieldFormat(ColumnData.sFieldFormat),
	m_sHeading(ColumnData.sHeading),
	m_iFormat(ColumnData.iFormat),
	m_iWidth(ColumnData.iWidth)
{
}


BOOL CColumnFormatDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_ctrlFieldName.SetWindowText(m_sFieldName);
	m_ctrlFieldFormat.SetWindowText(m_sFieldFormat);
	m_ctrlHeading.SetWindowText(m_sHeading);
	
	m_ctrlFormat.AddString(_T("LVCFMT_LEFT"));
	m_ctrlFormat.AddString(_T("LVCFMT_RIGHT"));
	m_ctrlFormat.AddString(_T("LVCFMT_CENTER"));
	m_ctrlFormat.SetItemData(0, LVCFMT_LEFT);
	m_ctrlFormat.SetItemData(1, LVCFMT_RIGHT);
	m_ctrlFormat.SetItemData(2, LVCFMT_CENTER);
	for (int i = 0; i < m_ctrlFormat.GetCount(); i++)
	{
		if (m_ctrlFormat.GetItemData(i) == static_cast<DWORD>(m_iFormat))
		{
			m_ctrlFormat.SetCurSel(i);
			break;
		}
	}

	CString sWidth;
	sWidth.Format(_T("%d"), m_iWidth);
	m_ctrlWidth.SetWindowText(sWidth);
	
	m_ctrlFieldFormat.SetFocus();

	return FALSE;
}



void CColumnFormatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColumnFormatDlg)
	DDX_Control(pDX, ID_COLUMNFORMAT_FIELDNAME, m_ctrlFieldName);
	DDX_Control(pDX, ID_COLUMNFORMAT_FIELDFORMAT, m_ctrlFieldFormat);
	DDX_Control(pDX, ID_COLUMNFORMAT_HEADING, m_ctrlHeading);
	DDX_Control(pDX, ID_COLUMNFORMAT_FORMAT, m_ctrlFormat);
	DDX_Control(pDX, ID_COLUMNFORMAT_WIDTH, m_ctrlWidth);
	DDX_Control(pDX, ID_COLUMNFORMAT_OK, m_ctrlOK);
	DDX_Control(pDX, ID_COLUMNFORMAT_CANCEL, m_ctrlCancel);
	//}}AFX_DATA_MAP
}


void CColumnFormatDlg::OnKillFocusFieldFormat() 
{
	CString sFieldFormat;
	m_ctrlFieldFormat.GetWindowText(sFieldFormat);

	if (!m_pOpenDlg->CheckFormat(sFieldFormat))
		m_ctrlFieldFormat.SetFocus();
}


void CColumnFormatDlg::OnKillFocusWidth() 
{
	CString sWidth;
	m_ctrlWidth.GetWindowText(sWidth);
	sWidth.TrimRight();

	if (sWidth.IsEmpty())
	{
		m_ctrlWidth.SetFocus();
		return;
	}
}


void CColumnFormatDlg::OnOK() 
{
	m_ctrlFieldFormat.GetWindowText(m_sFieldFormat);
	m_ctrlHeading.GetWindowText(m_sHeading);
	m_iFormat = m_ctrlFormat.GetItemData(m_ctrlFormat.GetCurSel());
	
	CString sWidth;
	m_ctrlWidth.GetWindowText(sWidth);
	m_iWidth = atoi(sWidth);

	CDialog::OnOK();
}


void CColumnFormatDlg::OnCancel() 
{
	CDialog::OnCancel();
}