#include "stdafx.h"
#include "ErrorBox.h"
#include "Details.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CErrorBox, CDialog)
	//{{AFX_MSG_MAP(CErrorBox)
	ON_BN_CLICKED(ID_ERRORBOX_DETAILS, OnDetails)
	ON_BN_CLICKED(ID_ERRORBOX_OK, OnOK)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CErrorBox::CErrorBox(LPCTSTR lpszMessage1,
	LPCTSTR lpszMessage2, 
	LPCTSTR lpszMessage3) :
	CDialog(IDD, NULL),
	m_sMessage1(lpszMessage1),
	m_sMessage2(lpszMessage2),
	m_sMessage3(lpszMessage3)
{
	SaveError();
	DoModal();
}


void CErrorBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CErrorBox)
	DDX_Control(pDX, ID_ERRORBOX_MESSAGE1, m_ctrlMessage1);
	DDX_Control(pDX, ID_ERRORBOX_MESSAGE2, m_ctrlMessage2);
	DDX_Control(pDX, ID_ERRORBOX_MESSAGE3, m_ctrlMessage3);
	DDX_Control(pDX, ID_ERRORBOX_OK, m_ctrlOK);
	DDX_Control(pDX, ID_ERRORBOX_DETAILS, m_ctrlDetails);
	//}}AFX_DATA_MAP
}


BOOL CErrorBox::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_ctrlMessage1.SetWindowText(m_sMessage1);
	m_ctrlMessage2.SetWindowText(m_sMessage2);
	m_ctrlMessage3.SetWindowText(m_sMessage3);

	m_ctrlOK.SetFocus();

	return FALSE;
}


void CErrorBox::OnOK() 
{
	if (GetFocus() == GetDlgItem(ID_ERRORBOX_OK))
		CDialog::OnOK();
	else
		OnDetails();
}


void CErrorBox::OnDetails() 
{
	CDetails Details(m_sMessage1, m_sMessage2, m_sMessage3);
	Details.DoModal();
}


void CErrorBox::SaveError()
{
	COleDateTime ErrorTime(COleDateTime::GetCurrentTime());

	CString sFileName = CString(AfxGetApp()->m_pszExeName) + CString(_T(".err"));
	CStdioFile ErrorFile(sFileName, CFile::modeCreate | CFile::modeNoTruncate |
		CFile::modeWrite | CFile::shareDenyNone | CFile::typeText);
	ErrorFile.SeekToEnd();

	ErrorFile.WriteString(ErrorTime.Format(_T("%d/%m/%Y  %H:%M:%S")) + CString(_T("\n")));
	ErrorFile.WriteString(m_sMessage1 + CString(_T("\n")));
	ErrorFile.WriteString(m_sMessage2 + CString(_T("\n")));
	ErrorFile.WriteString(m_sMessage3 + CString(_T("\n")));
	ErrorFile.WriteString(_T("\n"));
}
