#if !defined(AFX_OPENDLG_H__01C195A4_B723_11D5_A5F2_00600816F009__INCLUDED_)
#define AFX_OPENDLG_H__01C195A4_B723_11D5_A5F2_00600816F009__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>

class CSQLTableDoc;


class COpenDlg : public CDialog
{
// Construction
public:
	COpenDlg(CWnd* pParent = NULL);   // standard constructor
	COpenDlg(CWnd* pParent, CSQLTableDoc* pSQLTableDoc);
	~COpenDlg();

// Attributes
	struct CColumnData
	{
		CString sFieldName;
		CString sFieldFormat;
		CString sHeading;
		int iFormat;
		int iWidth;
	};

	// For storing columns' data
	CArray<CColumnData, CColumnData&> m_arrColumns;

	CString m_sTableName;
	CString m_sDataFieldName;
	CString m_sSort;
	CString m_sSortFormat;
	CString m_sOptimizerHints;
	CString m_sFilter;
	DWORD m_dwStyle;
	BOOL m_bEnableIteratorBar;

// Operations	
	BOOL CheckFormat(CString& sFormat);
	
// Dialog Data
	//{{AFX_DATA(COpenDlg)
	enum { IDD = IDD_OPEN };
	CListBox	m_ctrlTables;
	CButton	m_ctrlSelectTable;
	CListBox	m_ctrlFields;
	CButton	m_ctrlSetDataField;
	CEdit	m_ctrlDataField;
	CButton	m_ctrlAdd;
	CButton	m_ctrlRemove;
	CListBox	m_ctrlColumns;
	CButton	m_ctrlColumnFormat;
	CEdit	m_ctrlSort;
	CEdit	m_ctrlSortFormat;
	CEdit	m_ctrlOptimizerHints;
	CEdit	m_ctrlFilter;
	CButton	m_ctrlFixedColumns;
	CButton	m_ctrlShowVertGridLines;
	CButton	m_ctrlEnableIteratorBar;
	CButton	m_ctrlOK;
	CButton	m_ctrlCancel;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COpenDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COpenDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelectTable();
	afx_msg void OnSetDataField();
	afx_msg void OnAdd();
	afx_msg void OnRemove();
	afx_msg void OnColumnFormat();
	afx_msg void OnKillFocusSortFormat();
	afx_msg void OnOK();
	afx_msg void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Attributes
private:
	CSQLTableDoc* m_pSQLTableDoc;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPENDLG_H__01C195A4_B723_11D5_A5F2_00600816F009__INCLUDED_)
