#include "stdafx.h"
#include "SQLViewApp.h"
#include "MainFrm.h"
#include "SQLTableDoc.h"
#include "SQLTableView.h"
#include "ConnectDlg.h"
#include "ConnectingDlg.h"
#include "AboutDlg.h"
#include "ErrorBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CSQLViewApp, CWinApp)
	//{{AFX_MSG_MAP(CSQLViewApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CSQLViewApp theApp;


CSQLViewApp::CSQLViewApp() :
	m_pSQLTableView(NULL)
{
}


BOOL CSQLViewApp::InitInstance()
{
	Enable3dControls();

	::AfxOleInit();

	m_hIcon = LoadIcon(IDR_MAINFRAME);

	CConnectDlg dlgConnect;
	
	BOOL bSuccess = FALSE;
	while (!bSuccess)
	{
		if (dlgConnect.DoModal() == IDCANCEL)
			ExitProcess(0);

		CConnectingDlg dlgConnecting;
		dlgConnecting.Create(IDD_CONNECTING);
		BeginWaitCursor();

		CString sConnectionString = CString(_T("driver={SQL Server};server=")) +
			dlgConnect.m_sServer +
			CString(_T(";database=")) +
			dlgConnect.m_sDatabase;

		m_pConnection.CreateInstance(__uuidof(Connection));
		m_pConnection->ConnectionTimeout = 60;
		m_pConnection->Mode = adModeReadWrite;

		try
		{
			m_pConnection->Open(_bstr_t(sConnectionString),
				_bstr_t(dlgConnect.m_sLogin),
				_bstr_t(dlgConnect.m_sPassword),
				adModeUnknown);

			EndWaitCursor();
			dlgConnecting.DestroyWindow();
			bSuccess = TRUE;
		}
		catch (_com_error& e)
		{
			EndWaitCursor();
			dlgConnecting.DestroyWindow();

			CErrorBox(e.Description(), e.ErrorMessage(), e.Source());
		}
	}

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CSQLTableDoc),
		RUNTIME_CLASS(CMainFrame),
		RUNTIME_CLASS(CSQLTableView));
	AddDocTemplate(pDocTemplate);

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	POSITION Position = pDocTemplate->GetFirstDocPosition();
	CSQLTableDoc* pSQLTableDoc = static_cast<CSQLTableDoc*>(pDocTemplate->GetNextDoc(Position));
	pSQLTableDoc->OpenTable();

	return TRUE;
}


int CSQLViewApp::ExitInstance() 
{
	m_pConnection->Close();
	
	return CWinApp::ExitInstance();
}


BOOL CSQLViewApp::OnIdle(LONG lCount) 
{
	if (m_pSQLTableView)
		m_pSQLTableView->Update();
	
	return CWinApp::OnIdle(lCount);
}


void CSQLViewApp::OnAppAbout()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}