#include "stdafx.h"
#include "SQLViewApp.h"
#include "SeekItemDlg.h"
#include "SQLTableView.h"
#include "ErrorBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CSeekItemDlg, CDialog)
	//{{AFX_MSG_MAP(CSeekItemDlg)
	ON_BN_CLICKED(ID_SEEKITEM_OK, OnOK)
	ON_BN_CLICKED(ID_SEEKITEM_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CSeekItemDlg::CSeekItemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSeekItemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSeekItemDlg)
	//}}AFX_DATA_INIT
}


BOOL CSeekItemDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_ctrlData.SetFocus();
	
	return FALSE;
}


void CSeekItemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSeekItemDlg)
	DDX_Control(pDX, IDC_SEEKITEM_DATA, m_ctrlData);
	DDX_Control(pDX, ID_SEEKITEM_OK, m_ctrlOK);
	DDX_Control(pDX, ID_SEEKITEM_CANCEL, m_ctrlCancel);
	//}}AFX_DATA_MAP
}


void CSeekItemDlg::OnOK() 
{
	CString sData;
	m_ctrlData.GetWindowText(sData);

	vaData = _variant_t(sData);
	VARTYPE VarType = VT_BSTR;

	int iResult = IDOK;

	CString sSort;
	CString sSortFormat;
	CString sOptimizerHints;

	static_cast<CSQLViewApp*>(AfxGetApp())->m_pSQLTableView->
		GetSort(sSort, sSortFormat, 
		sOptimizerHints);

	// Most right symbol is a type format field
	CString sType = sSortFormat.Right(1);

	if ((sType != _T("s")) && (sType != _T("S")))
	{
		// At this case type of variant must be changed
		// to appropriate one
		if ((sType == _T("c")) || (sType == _T("C")))
		{
			VarType = VT_UI1;
		}
		else if ((sType == _T("d")) || (sType == _T("i")) ||
			(sType == _T("o")) || (sType == _T("u")) ||
			(sType == _T("x")) || (sType == _T("X")))
		{
			VarType = VT_I4;
		}
		else if ((sType == _T("e")) || (sType == _T("E")) ||
			(sType == _T("f")) || (sType == _T("g")) ||
			(sType == _T("G")))
		{
			VarType = VT_R8;
		}

		try
		{
			vaData.ChangeType(VarType);
		}
		catch(_com_error& e)
		{
			CErrorBox(e.ErrorMessage(),	_T("Error changing type of entered data:"),
				CString(_T("ORDER BY clause format is ")) + sSortFormat);
			
			iResult = IDCANCEL;
		}
	}

	EndDialog(iResult);
}


void CSeekItemDlg::OnCancel() 
{
	CDialog::OnCancel();
}
